<template>
  <q-page class="flex-center">
    <q-card>
      <q-card-section>
        <div class="row q-col-gutter-sm">
          <div class="col-12">
            <div class="my-content shadow-3">
              Company Name &nbsp; {{ form.company_name }}
            </div>
          </div>
          <div class="col-6">
            <div class="my-content shadow-3">
              Owner Name &nbsp; {{ form.name }}
            </div>
          </div>
          <div class="col-6">
            <div class="my-content shadow-3">Phone &nbsp; {{ form.phone }}</div>
          </div>
        </div>
      </q-card-section>
      <hr />
      <q-table
        :rows-per-page-options="[15, 25, 50]"
        :data="data"
        :columns="columns"
        :loading="loading"
        separator="cell"
        @request="onRequest"
        :pagination.sync="pagination"
        row-key="id"
      >
        <template slot="top" slot-scope="props">
          <div class="text-h6">Company {{ form.name }}</div>
          <div class="col" />
          <q-btn push rounded color="primary" icon="add" @click="add()"
            >Add Downline</q-btn
          >
          <!-- <q-btn push rounded color="primary" icon="add" @click="add()" >Loadong...</q-btn>             -->
        </template>
        <q-tr slot="body" slot-scope="props" :props="props">
          <q-td
            key="No"
            :props="props"
            :style="{ width: '20px', whiteSpace: 'normal' }"
            >{{ props.row.No }}</q-td
          >
          <q-td
            key="role"
            :props="props"
            :style="{ width: '100px', whiteSpace: 'normal' }"
            >{{ props.row.role_name }}
          </q-td>
          <q-td
            key="owner"
            :props="props"
            :style="{ width: '100px', whiteSpace: 'normal' }"
            >{{ props.row.parent_name }}
          </q-td>
          <q-td
            key="name"
            :props="props"
            :style="{ width: '200px', whiteSpace: 'normal' }"
            >{{ props.row.name }}</q-td
          >
          <q-td
            key="username"
            :props="props"
            :style="{ width: '100px', whiteSpace: 'normal' }"
            >{{ props.row.username }}
          </q-td>
          <q-td
            key="credit"
            :props="props"
            :style="{ width: '100px', whiteSpace: 'normal' }"
          >
            {{ props.row.credit | toUSD }}
          </q-td>
          <q-td
            key="phone"
            :props="props"
            :style="{ width: '100px', whiteSpace: 'normal' }"
            >{{ props.row.phone }}</q-td
          >
          <q-td
            key="status"
            :props="props"
            :style="{ width: '20px', whiteSpace: 'normal' }"
          >
            <q-toggle
              key="is_display"
              v-model="props.row.status"
              :false-value="0"
              :true-value="1"
              @input="ChangeStatus(props.row)"
            />
          </q-td>
          <q-td
            key="action"
            :props="props"
            :style="{ width: '20px', whiteSpace: 'normal' }"
          >
            <div class="row items-center q-gutter-x-sm justify-center no-wrap">
              <q-btn
                size="sm"
                round
                rounded
                color="secondary"
                icon="edit"
                @click="load(props.row)"
                class="q-mr-xs"
              />
              <q-btn
                size="sm"
                round
                rounded
                color="dark"
                icon="password"
                @click.prevent="
                  () => {
                    changePasswordModal.modal = true;
                    changePasswordModal.id = props.row.id;
                    changePasswordModal.username = props.row.username;
                  }
                "
                class="q-mr-xs"
              />
            </div>
          </q-td>
        </q-tr>
      </q-table>
    </q-card>
    <!-- add game -->
    <q-dialog
      full-width
      full-height
      v-model="modal_add"
      persistent
      transition-show="flip-down"
      transition-hide="flip-up"
    >
      <q-card>
        <q-bar>
          <q-space />
          <q-btn dense flat icon="close" v-close-popup>
            <q-tooltip>Close</q-tooltip>
          </q-btn>
        </q-bar>
        <q-card-section>
          <el-form
            :model="form_member"
            ref="form_member"
            :rules="rules_member"
            label-width="120px"
            class="demo-dynamic"
          >
            <el-form-item label="Role" prop="role">
              <q-select
                filled
                v-model="form_member.role"
                :options="role_options"
                :disable="this.role != 0"
                option-value="value"
                option-label="label"
                option-disable="inactive"
                emit-value
                map-options
              />
            </el-form-item>
            <el-form-item label="Owner" prop="owner">
              <q-select
                filled
                v-model="form_member.owner"
                :options="member_options"
                option-value="value"
                option-label="label"
                option-disable="inactive"
                emit-value
                map-options
                :disable="disable"
              />
            </el-form-item>
            <el-form-item label="Name" prop="name">
              <el-input
                v-model="form_member.name"
                autocomplete="off"
              ></el-input>
            </el-form-item>
            <el-form-item label="Credit" prop="credit">
              <currency-input
                v-model="form_member.credit"
                currency="THB"
                @change="check_credit"
              />
            </el-form-item>
            <el-form-item label="Username" prop="username">
              <el-input
                v-model="form_member.username"
                autocomplete="off"
              ></el-input>
            </el-form-item>
            <el-form-item label="Password" prop="password">
              <el-input
                v-model="form_member.password"
                type="password"
                autocomplete="off"
              ></el-input>
            </el-form-item>
            <el-form-item label="Confrim" prop="confrim">
              <el-input
                type="password"
                v-model="form_member.confrim"
                autocomplete="off"
              ></el-input>
            </el-form-item>
            <el-form-item label="Phone" prop="phone">
              <el-input
                v-model="form_member.phone"
                autocomplete="off"
              ></el-input>
            </el-form-item>
          </el-form>
          <hr />
          <q-table
            :rows-per-page-options="[15, 25, 50]"
            :data="provider"
            :columns="game_columns"
            separator="cell"
            row-key="id"
            virtual-scroll
            :pagination.sync="pagination_provider"
          >
            <q-tr slot="header" slot-scope="props" :props="props">
              <q-th key="status_" :props="props">
                <q-checkbox
                  keep-color
                  v-model="checkall"
                  color="green"
                  @input="onSelection"
                />
              </q-th>
              <q-th key="name" :props="props">Name</q-th>
              <q-th key="percent" :props="props">
                <div class="row">
                  <div class="col-12">Percent</div>
                  <div class="col-12">
                    <el-input-number
                      v-if="checkall == 1 && 6 > role"
                      v-model="percent_"
                      controls-position="right"
                      :min="0"
                      :max="percent"
                      @change="syncpercent"
                    ></el-input-number>
                  </div>
                </div>
              </q-th>
              <q-th key="commission" :props="props">
                <div class="row">
                  <div class="col-12">Commission</div>
                  <div class="col-12">
                    <el-input-number
                      v-if="checkall == 1 && 6 > role"
                      v-model="commission_"
                      controls-position="right"
                      :min="0"
                      :max="10"
                      @change="synccommison"
                    ></el-input-number>
                  </div>
                </div>
              </q-th>
            </q-tr>
            <q-tr slot="body" slot-scope="props" :props="props">
              <q-td
                key="status_"
                :props="props"
                :style="{ width: '50px', whiteSpace: 'normal' }"
              >
                <q-checkbox
                  keep-color
                  v-model="props.row.status_"
                  color="green"
                  @input="rowSelect"
                />
              </q-td>
              <q-td
                key="name"
                :props="props"
                :style="{ width: '200px', whiteSpace: 'normal' }"
                >{{ props.row.name }}
              </q-td>
              <q-td
                key="percent"
                :props="props"
                :style="{ width: '200px', whiteSpace: 'normal' }"
              >
                <template>
                  <el-input-number
                    v-if="props.row.status_ == 1 && 6 > role"
                    v-model="props.row.percent_"
                    controls-position="right"
                    :min="0"
                    :max="props.row.percent"
                  ></el-input-number>
                </template>
              </q-td>
              <q-td
                key="commission"
                :props="props"
                :style="{ width: '200px', whiteSpace: 'normal' }"
              >
                <template>
                  <el-input-number
                    v-if="props.row.status_ == 1 && 6 > role"
                    v-model="props.row.commission_"
                    controls-position="right"
                    :min="0"
                    :max="props.row.commission"
                  ></el-input-number>
                </template>
              </q-td>
            </q-tr>
          </q-table>
        </q-card-section>
        <q-card-actions align="right">
          <q-btn
            push
            rounded
            color="primary"
            @click="insert()"
            v-show="permissions.includes('add_member')"
            >Submit
          </q-btn>
          <q-btn push rounded color="primary" v-close-popup>Cancel</q-btn>
        </q-card-actions>
      </q-card>
    </q-dialog>

    <!-- update game -->
    <q-dialog
      full-width
      full-height
      v-model="modal_edit"
      persistent
      transition-show="flip-down"
      transition-hide="flip-up"
    >
      <q-card>
        <q-bar>
          <q-space />
          <q-btn dense flat icon="close" v-close-popup>
            <q-tooltip>Close</q-tooltip>
          </q-btn>
        </q-bar>
        <q-card-section>
          <el-form
            :model="form_member_edit"
            ref="form_member_edit"
            :rules="rules_member_edit"
            label-width="120px"
            class="demo-dynamic"
          >
            <el-form-item label="Role" prop="role">
              <q-select
                filled
                v-model="form_member_edit.role"
                :options="role_options"
                :disable="disable"
                option-value="value"
                option-label="label"
                option-disable="inactive"
                emit-value
                map-options
              />
            </el-form-item>
            <el-form-item label="Owner" prop="owner">
              <q-select
                filled
                v-model="form_member_edit.owner"
                :options="member_options"
                :disable="disable"
                option-value="value"
                option-label="label"
                option-disable="inactive"
                emit-value
                map-options
              />
            </el-form-item>
            <el-form-item label="Name" prop="name">
              <el-input
                v-model="form_member_edit.name"
                autocomplete="off"
              ></el-input>
            </el-form-item>
            <el-form-item label="Credit" prop="credit">
              <currency-input
                v-model="form_member_edit.credit"
                currency="THB"
                @change="check_credit_update"
              />
            </el-form-item>
            <el-form-item label="Username" prop="username">
              <el-input
                v-model="form_member_edit.username"
                autocomplete="off"
              ></el-input>
            </el-form-item>
            <el-form-item label="Phone" prop="phone">
              <el-input
                v-model="form_member_edit.phone"
                autocomplete="off"
              ></el-input>
            </el-form-item>
            <!--   <el-form-item label="Domain" prop="domain" v-show="domain">
                <el-input v-model="form_member_edit.domain" autocomplete="off"></el-input>
              </el-form-item> -->
          </el-form>
          <hr />
          <q-table
            :rows-per-page-options="[15, 25, 50]"
            :data="provider"
            :columns="game_columns"
            separator="cell"
            row-key="id"
            virtual-scroll
            :pagination.sync="pagination_provider"
          >
            <q-tr slot="header" slot-scope="props" :props="props">
              <q-th key="status_" :props="props">
                <q-checkbox
                  keep-color
                  v-model="checkall"
                  color="green"
                  @input="onSelection"
                />
              </q-th>
              <q-th key="name" :props="props">Name</q-th>
              <q-th key="percent" :props="props">
                <div class="row">
                  <div class="col-12">Percent</div>
                  <div class="col-12">
                    <el-input-number
                      v-if="checkall == 1 && 6 > role"
                      v-model="percent_"
                      controls-position="right"
                      :min="0"
                      :max="percent"
                      @change="syncpercent"
                    ></el-input-number>
                  </div>
                </div>
              </q-th>
              <q-th key="commission" :props="props">
                <div class="row">
                  <div class="col-12">Commission</div>
                  <div class="col-12">
                    <el-input-number
                      v-if="checkall == 1 && 6 > role"
                      v-model="commission_"
                      controls-position="right"
                      :min="0"
                      :max="10"
                      @change="synccommison"
                    ></el-input-number>
                  </div>
                </div>
              </q-th>
            </q-tr>
            <q-tr slot="body" slot-scope="props" :props="props">
              <q-td
                key="status_"
                :props="props"
                :style="{ width: '50px', whiteSpace: 'normal' }"
              >
                <q-checkbox
                  keep-color
                  v-model="props.row.status_"
                  color="green"
                  @input="rowSelect"
                />
              </q-td>
              <q-td
                key="name"
                :props="props"
                :style="{ width: '200px', whiteSpace: 'normal' }"
                >{{ props.row.name }}
              </q-td>
              <q-td
                key="percent"
                :props="props"
                :style="{ width: '200px', whiteSpace: 'normal' }"
              >
                <template>
                  <el-input-number
                    v-if="props.row.status_ == 1 && 6 > role"
                    v-model="props.row.percent_"
                    controls-position="right"
                    :min="0"
                    :max="props.row.percent"
                  ></el-input-number>
                </template>
              </q-td>
              <q-td
                key="commission"
                :props="props"
                :style="{ width: '200px', whiteSpace: 'normal' }"
              >
                <template>
                  <el-input-number
                    v-if="props.row.status_ == 1 && 6 > role"
                    v-model="props.row.commission_"
                    controls-position="right"
                    :min="0"
                    :max="props.row.commission"
                  ></el-input-number>
                </template>
              </q-td>
            </q-tr>
          </q-table>
        </q-card-section>
        <q-card-actions align="right">
          <q-btn push rounded color="primary" @click="Update()">Submit</q-btn>
          <q-btn push rounded color="primary" v-close-popup>Cancel</q-btn>
        </q-card-actions>
      </q-card>
    </q-dialog>
    <changePasswordModal v-bind.sync="changePasswordModal" />
  </q-page>
</template>

<script>
import { QSpinnerGears } from "quasar";
import changePasswordModal from "components/changePasswordModal";

export default {
  name: "Owner",
  components: { changePasswordModal },
  data() {
    var validatePass = (rule, value, callback) => {
      if (value === "") {
        callback(new Error("Please input the password"));
      } else {
        if (this.form_member.confrim !== "") {
          this.$refs.form_member.validateField("confrim");
        }
        callback();
      }
    };
    var validatePass2 = (rule, value, callback) => {
      if (value === "") {
        callback(new Error("Please input the password again"));
      } else if (value !== this.form_member.password) {
        callback(new Error("Two inputs don't match!"));
      } else {
        callback();
      }
    };
    return {
      changePasswordModal: {
        modal: false,
        username: undefined,
        id: undefined
      },
      data: [],
      search: "",
      modal_add: false,
      modal_edit: false,
      // domain: false,
      type_options: [],
      provider: [],
      options: [
        { value: 1, label: "Enable" },
        { value: 0, label: "Disable" }
      ],
      btn: [
        { label: "Disable", color: "red" },
        { label: "Enable", color: "primary" }
      ],
      role_options: [],
      member_options: [],
      columns: [
        {
          name: "No",
          label: "No",
          field: "No",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "role",
          label: "Role",
          field: "role",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "owner",
          label: "Owner",
          field: "owner",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "name",
          label: "Name",
          field: "name",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "username",
          label: "Username",
          field: "username",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "credit",
          label: "Credit",
          field: "credit",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "phone",
          label: "Phone",
          field: "phone",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "status",
          label: "Status",
          field: "status",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "action",
          label: "Action",
          field: "id",
          require: true,
          align: "left",
          stortable: true
        }
      ],
      game_columns: [
        {
          name: "image",
          label: "Image",
          field: "image",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "name",
          label: "Name",
          field: "name",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "percent",
          label: "Percent",
          field: "percent",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "commission",
          label: "Commission",
          field: "commission",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "status_",
          label: "Status",
          field: "status_",
          require: true,
          align: "left",
          stortable: true
        }
      ],
      separator: "horizontal",
      pagination: {
        sortBy: null,
        descending: false,
        page: 1,
        rowsPerPage: 10,
        rowsNumber: 10
      },
      pagination_provider: {
        rowsPerPage: 0
      },
      form: {},
      form_member: {
        role: "",
        owner: "",
        name: "",
        credit: null,
        username: "",
        password: "",
        confrim: "",
        company: "",
        game_member: [],
        domain: "",
        parent: ""
      },
      form_member_edit: {},
      rules_member: {
        name: [
          { required: true, message: "Please input name", trigger: "blur" }
        ],
        role: [
          { required: true, message: "Please select status", trigger: "change" }
        ],
        owner: [
          { required: true, message: "Please select owner", trigger: "change" }
        ],
        credit: [
          { required: true, message: "Please input credit", trigger: "blur" }
        ],
        username: [
          { required: true, message: "Please input username", trigger: "blur" }
        ],
        password: [
          { required: true, validator: validatePass, trigger: "blur" }
        ],
        confrim: [
          { required: true, validator: validatePass2, trigger: "blur" }
        ],
        phone: [
          { required: true, message: "Please input phone", trigger: "blur" }
        ]
      },

      rules_member_edit: {
        name: [
          { required: true, message: "Please input name", trigger: "blur" }
        ],
        role: [
          { required: true, message: "Please select status", trigger: "change" }
        ],
        owner: [
          { required: true, message: "Please select owner", trigger: "change" }
        ],
        credit: [
          { required: true, message: "Please input credit", trigger: "blur" }
        ],
        phone: [
          { required: true, message: "Please input phone", trigger: "blur" }
        ]
        // domain: [{required: true, message: 'Please input domain', trigger: 'blur'}]
      },
      disable: true,
      show: true,
      credit_remain: 0,
      role: this.$q.sessionStorage.getItem("role"),
      permissions:
        this.$q.sessionStorage.getItem("permissions")["member"] != undefined
          ? this.$q.sessionStorage.getItem("permissions")["member"]
          : [],
      dataClone: [],
      checkall: false,
      checkall: false,
      commission_: 0,
      percent_: null,
      commission: 0,
      percent: 0,
      filter: {},
      loading: false,
      role_id: ""
    };
  },

  async created() {
    // this.form = await this.$services.member.readdownline({param: 'profile'})
    await this.getdata();
    await this.get_profile();
  },

  methods: {
    async onRequest(props) {
      this.$q.loading.show({
        spinner: QSpinnerGears,
        spinnerColor: "primary",
        message: "loading......"
      });
      try {
        this.loading = true;
        const { page, rowsPerPage, sortBy, descending } = props.pagination;
        this.filter.role_level = 5;
        this.filter.page_limit = rowsPerPage;
        this.filter.page = page;
        this.filter.company = this.$route.params.id;
        if (this.filter.name == "") {
          delete this.filter.name;
        }

        if (this.filter.user == "") {
          delete this.filter.user;
        }

        if (this.filter.phone == "") {
          delete this.filter.phone;
        }

        if (this.filter.status == 3) {
          delete this.filter.status;
        }
        this.filter.role = this.role_id;
        let result = await this.$services.member.readdownline(this.filter);
        this.pagination.rowsNumber = result.total;
        this.data = result.results;
        this.$services.updateindex(this.data);
        this.pagination.page = page;
        this.pagination.rowsPerPage = rowsPerPage;
        this.pagination.sortBy = sortBy;
        this.pagination.descending = descending;
        this.loading = false;
        this.$q.loading.hide();
      } catch (e) {
        this.$services.error(e.response, this.$route);
      }
    },

    async get_profile() {
      let data = await this.$services.member.readdownline({
        param: "profile",
        page_limit: 1
      });
      this.form = data.results[0];
      this.optionOwner();
    },

    async getdata() {
      let ctx = this;
      this.role_options = [];
      this.$services.role
        .read()
        .then(async data => {
          const currentRow = data.find(x => x.level == 4);
          this.role_options = data.map(row => {
            return { value: row.id, label: row.name, level: row.level };
          });
          this.role_id = currentRow.id;
          await this.onRequest({
            pagination: this.pagination,
            role: this.role_id
          });
        })
        .catch(function(e) {
          ctx.$services.error(e.response, ctx.$route);
        });
    },

    optionOwner() {
      this.member_options = [];
      this.member_options.push({ value: this.form.id, label: this.form.name });
    },

    async get_subscribe(id) {
      try {
        this.provider = [];
        this.provider = await this.$services.subscribe.read(id);
        this.percent = Math.max.apply(
          Math,
          this.provider.map(function(obj) {
            return obj.percent;
          })
        );
        this.commission = Math.max.apply(
          Math,
          this.provider.map(function(obj) {
            return obj.commission;
          })
        );
      } catch (e) {
        this.$services.error(e.response, ctx.$route);
      }
    },

    roleChange(value) {
      this.role_options.forEach(row => {
        if (row.value == value) {
          this.role = row.level;
        }
      });
    },

    add() {
      this.modal_add = true;
      this.percent = null;
      this.commission = null;
      this.percent_ = null;
      this.commission_ = null;
      this.checkall = false;
      this.get_subscribe(this.form.id);
      this.form_member = {
        role: this.role_id,
        owner: this.form.id,
        name: "",
        credit: null,
        username: "",
        password: "",
        confrim: "",
        company: this.form.company,
        game_member: [],
        parent: ""
      };
    },

    async insert() {
      let ctx = this;
      this.form_member.game_member = [];
      this.provider.forEach(row => {
        if (row.status_ != undefined && row.status_ == 1) {
          this.form_member.game_member.push({
            provider_id: row.provider,
            percent: row.percent_,
            commission: row.commission_
          });
        }
      });
      this.$refs.form_member.validate(valid => {
        if (valid) {
          this.$q.loading.show({
            spinner: QSpinnerGears,
            spinnerColor: "primary",
            message: "Process Save..."
          });
          this.form_member.parent = this.form.pid;
          this.$services.member
            .add(this.form_member)
            .then(function(data) {
              ctx.getdata();
              ctx.modal_add = false;
              ctx.$q.loading.hide();
              ctx.$services.success("Save Downline Success");
            })
            .catch(function(e) {
              ctx.$services.error(e.response, ctx.$route);
            });
          this.$q.loading.hide();
        }
      });
    },

    async load(data) {
      let ctx = this;
      this.checkall = false;
      this.percent = null;
      this.commission = null;
      this.percent_ = null;
      this.commission_ = null;
      this.provider = [];
      // this.get_subscribe(data.owner)
      this.roleChange(data.role);
      let provider = await this.$services.subscribe.read(data.owner);
      this.form_member_edit = Object.assign({}, data);
      this.credit = data.credit;
      this.modal_edit = true;
      let subscribe = await this.$services.subscribe.read(data.id);
      provider.forEach(row => {
        let result = subscribe.filter(obj => {
          return obj.provider === row.provider;
        });
        if (result.length > 0) {
          row["percent_"] = result[0].percent;
          row["commission_"] = result[0].commission;
          row["id_"] = result[0].id;
          row["status_"] = true;
        }
      });
      this.provider = provider;
      this.percent = Math.max.apply(
        Math,
        this.provider.map(function(obj) {
          return obj.percent;
        })
      );
      this.commission = Math.max.apply(
        Math,
        this.provider.map(function(obj) {
          return obj.commission;
        })
      );
      this.rowSelect();
    },

    async Update() {
      let ctx = this;
      this.form_member_edit.game_member = [];
      this.provider.forEach(row => {
        if (row.id_ != undefined) {
          if (row.status_) {
            this.form_member_edit.game_member.push({
              id: row.id_,
              provider_id: row.provider,
              percent: row.percent_,
              commission: row.commission_
            });
          }
        } else if (row.status_ != undefined) {
          this.form_member_edit.game_member.push({
            provider_id: row.provider,
            percent: row.percent_,
            commission: row.commission_
          });
        }
      });
      this.$refs.form_member_edit.validate(valid => {
        if (valid) {
          this.$q.loading.show({
            spinner: QSpinnerGears,
            spinnerColor: "primary",
            message: "Process Save..."
          });
          this.$services.member
            .update(this.form_member_edit, this.form_member_edit.id)
            .then(function(data) {
              ctx.getdata();
              ctx.modal_edit = false;
              ctx.$q.loading.hide();
              ctx.$services.success("Update Downline Success");
            })
            .catch(function(e) {
              ctx.$services.error(e.response, ctx.$route);
            });
          this.$q.loading.hide();
        }
      });
    },

    async check_credit(value) {
      return;

      try {
        let data = await this.$services.member.checkcredit({
          company: this.$route.params.id,
          owner: this.form_member.owner,
          member: null
        });
        if (value > data[0].credit_remain) {
          this.form_member.credit = data[0].credit_remain;
        }
      } catch (e) {
        this.$services.error(e.response, ctx.$route);
      }
    },

    async check_credit_update(value) {
      return;

      try {
        let data = await this.$services.member.checkcredit({
          company: this.$route.params.id,
          owner: this.form_member_edit.owner,
          member: this.form_member_edit.id
        });
        if (value > data[0].credit_remain) {
          this.form_member_edit.credit = data[0].credit_remain;
        }
      } catch (e) {
        this.$services.error(e.response, ctx.$route);
      }
    },

    ChangeStatus(row) {
      const prev = row.status == 0 ? 1 : 0;

      let ctx = this;
      this.$q
        .dialog({
          title: "Confirm",
          message: `Do you really want Change Status to Downline ${row.name} later, ok?`,
          ok: {
            push: true
          },
          cancel: {
            push: true,
            color: "negative"
          },
          persistent: true
        })
        .onOk(() => {
          // if (row.status == 1) {
          //   row.status = 0
          // } else {
          //   row.status = 1
          // }
          this.$services.member
            .update(row, row.id)
            .then(function(data) {
              ctx.getdata();
              ctx.$services.success("Update Downline Success");
            })
            .catch(function(e) {
              this.$dialog.errorException(e);
              row.status = prev;
            });
        })
        .onCancel(() => {
          // console.log('>>>> Cancel')
          row.status = prev;
        });
    },

    rowSelect(value) {
      if (
        this.provider.filter(row => {
          return row.status_ == 1;
        }).length == this.provider.length
      ) {
        this.checkall = true;
      } else {
        this.checkall = false;
      }
    },

    onSelection(value) {
      this.provider.forEach(row => {
        row.status_ = value;
      });
    },

    syncpercent(value) {
      this.provider.forEach(row => {
        row.percent_ = row.percent >= value ? value : row.percent;
      });
    },

    synccommison(value) {
      this.provider.forEach(row => {
        row.commission_ = row.commission > value ? value : row.commission;
      });
    }
  },

  filters: {
    toUSD(value) {
      return `${value.toLocaleString()}`;
    }
  }
};
</script>

<style lang="sass" scoped>
.example-item

  width: 32%

.my-content
  padding: 10px 15px
  border: 1px solid rgba(86, 61, 124, .2)
</style>

<style type="text/css">
img {
  border: 0.5px solid #ddd;
  border-radius: 8px;
  padding: 5px;
  width: 100%;
}

.image {
  border: 0.5px solid #ddd;
  border-radius: 8px;
  padding: 5px;
  width: 50%;
}
</style>
